/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 * 
 * $Id: Clar2v.cpp,v 1.2 2009/09/12 07:59:09 nakatamaho Exp $ 
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
/*
Copyright (c) 1992-2007 The University of Tennessee.  All rights reserved.

$COPYRIGHT$

Additional copyrights may follow

$HEADER$

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer. 
  
- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer listed
  in this license in the documentation and/or other materials
  provided with the distribution.
  
- Neither the name of the copyright holders nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.
  
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT  
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT  
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/

#include <mblas.h>
#include <mlapack.h>

void
Clar2v(INTEGER n, COMPLEX * x, COMPLEX * y, COMPLEX * z, INTEGER incx,
    REAL * c, COMPLEX * s, INTEGER incc)
{
    INTEGER i;
    COMPLEX t2, t3, t4;
    REAL t5, t6;
    INTEGER ic;
    REAL ci;
    COMPLEX si;
    INTEGER ix;
    REAL xi, yi;
    COMPLEX zi;
    REAL t1i, t1r, sii, zii, sir, zir;
    COMPLEX mtemp1;

    ix = 1;
    ic = 1;
    for (i = 0; i < n; i++) {
	xi = x[ix].re;
	yi = y[ix].re;
	zi = z[ix];
	zir = zi.re;
	zii = zi.im;
	ci = c[ic];
	si = s[ic];
	sir = si.re;
	sii = si.im;
	t1r = sir * zir - sii * zii;
	t1i = sir * zii + sii * zir;
	t2 = ci * zi;
	t3 = t2 - conjg(si) * xi;
	t4 = conjg(t2) + si * yi;
	t5 = ci * xi + t1r;
	t6 = ci * yi - t1r;
	x[ix] = ci * t5 + (sir * t4.re + sii * t4.im);
	y[ix] = ci * t6 - (sir * t3.re - sii * t3.im);
	mtemp1.re = t6;
	mtemp1.im = t1i;
	z[ix] = ci * t3 + conjg(si) * mtemp1;
	ix = ix + incx;
	ic = ic + incc;
    }
    return;
}
